var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { utilResponsive } from './utilResponsive';
import { IdDeviceBreakpointsByWidth, IdMobileHeight } from './IdDeviceBreakpoints';
import { windowDimensionSubs } from "./index";
export var IdResponsiveRenderOnlyIn;
(function (IdResponsiveRenderOnlyIn) {
    IdResponsiveRenderOnlyIn["Mobile"] = "Mobile";
    IdResponsiveRenderOnlyIn["MobilePortrait"] = "MobilePortrait";
    IdResponsiveRenderOnlyIn["MobileLandScape"] = "MobileLandScape";
    IdResponsiveRenderOnlyIn["Tablet"] = "Tablet";
    IdResponsiveRenderOnlyIn["Laptop"] = "Laptop";
})(IdResponsiveRenderOnlyIn || (IdResponsiveRenderOnlyIn = {}));
var _a = utilResponsive.getWindowDimensions(), width = _a.width, height = _a.height;
var initialState = { width: width, height: height };
var Responsive = /** @class */ (function (_super) {
    __extends(Responsive, _super);
    function Responsive(props) {
        var _this = _super.call(this, props) || this;
        _this.state = initialState;
        _this.componentWillUnmount = function () {
            _this.windowDimensionSubscription$.unsubscribe();
        };
        _this.render = function () {
            var children = _this.props.children;
            var _a = _this.state, width = _a.width, height = _a.height;
            var shouldRenderChildren = shouldRender(_this.getDisplayInArray(), width, height);
            return (React.createElement(React.Fragment, null, shouldRenderChildren ? children : null));
        };
        _this.getDisplayInArray = function () {
            var displayIn = _this.props.displayIn;
            return Array.isArray(displayIn) ? displayIn : [displayIn];
        };
        var self = _this;
        _this.windowDimensionSubscription$ = windowDimensionSubs.subscribe(function (dimension) {
            self.setState(__assign({}, dimension, { shouldRender: shouldRender(_this.getDisplayInArray(), dimension.width, dimension.height) }));
        });
        return _this;
    }
    return Responsive;
}(React.PureComponent));
export { Responsive };
var shouldRender = function (display, width, height) {
    if (display.indexOf(IdResponsiveRenderOnlyIn.Laptop) !== -1 && width >= IdDeviceBreakpointsByWidth.laptop_min) {
        return true;
    }
    if (display.indexOf(IdResponsiveRenderOnlyIn.Tablet) !== -1 && (width <= IdDeviceBreakpointsByWidth.tablet_max && width >= IdDeviceBreakpointsByWidth.tablet_min)) {
        return true;
    }
    // For mobile regardless of orientation
    if (display.indexOf(IdResponsiveRenderOnlyIn.Mobile) !== -1 && width <= IdDeviceBreakpointsByWidth.mobile_max) {
        return true;
    }
    if (display.indexOf(IdResponsiveRenderOnlyIn.MobilePortrait) !== -1 && (width <= IdDeviceBreakpointsByWidth.mobile_max && height >= IdMobileHeight.mobileLandscape_max)) {
        return true;
    }
    return !!(display.indexOf(IdResponsiveRenderOnlyIn.MobileLandScape) !== -1 && (width <= IdDeviceBreakpointsByWidth.mobile_max && height <= IdMobileHeight.mobileLandscape_min));
};
//# sourceMappingURL=Responsive.js.map