var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var _a;
import * as React from 'react';
import { Subject } from 'rxjs';
import { share } from 'rxjs/operators';
import { utilResponsive } from './utilResponsive';
import { IdDeviceOrientation, IdDeviceType, IdDeviceTypeBreakdown } from './IdDevice';
import { IdDeviceBreakpointsByWidth, IdMobileHeight } from './IdDeviceBreakpoints';
var windowDimensionSubject = new Subject();
export var windowDimensionSubs = windowDimensionSubject.pipe(share());
var ResponsiveWatcher = /** @class */ (function (_super) {
    __extends(ResponsiveWatcher, _super);
    function ResponsiveWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.render = function () {
            return null;
        };
        _this.updateDimensions = function () {
            var windowDimensionMetrics = utilResponsive.getWindowDimensions();
            _this.setState(windowDimensionMetrics);
            windowDimensionSubject.next(windowDimensionMetrics);
        };
        _this.componentWillMount = function () {
            _this.updateDimensions();
        };
        _this.componentDidMount = function () {
            window.addEventListener('resize', _this.updateDimensions);
        };
        _this.componentWillUnmount = function () {
            window.removeEventListener('resize', _this.updateDimensions);
        };
        return _this;
    }
    return ResponsiveWatcher;
}(React.PureComponent));
export { ResponsiveWatcher };
export var DeviceWidthObject = (_a = {},
    _a[IdDeviceTypeBreakdown.MobileSmall] = { max: 320, min: 0 },
    _a[IdDeviceTypeBreakdown.MobileMedium] = { max: 375, min: 321 },
    _a[IdDeviceTypeBreakdown.MobileLarge] = { max: 767, min: 376 },
    _a[IdDeviceTypeBreakdown.Tablet] = { max: 991, min: 768 },
    _a[IdDeviceTypeBreakdown.LaptopSmall] = { max: 1024, min: 992 },
    _a[IdDeviceTypeBreakdown.LaptopLarge] = { max: 1440, min: 1025 },
    _a[IdDeviceTypeBreakdown.LargerThanLaptop] = { max: 2560, min: 1441 },
    _a[IdDeviceTypeBreakdown.LargeScreenMax] = { max: 999999, min: 2561 },
    _a);
export var getDeviceTypeInfo = function () {
    var _a = utilResponsive.getWindowDimensions(), width = _a.width, height = _a.height;
    var buildDeviceDetails = {
        deviceType: '',
        deviceTypeVariant: '',
        orientation: IdDeviceOrientation.Portrait,
        width: width,
        height: height
    };
    if (height < width) {
        // Orientation is landscape
        buildDeviceDetails.orientation = IdDeviceOrientation.Landscape;
        if (height <= IdMobileHeight.mobileLandscape_max) {
            // Mobile (landscape)
            buildDeviceDetails.deviceType = IdDeviceType.Mobile;
            for (var devc in DeviceWidthObject) {
                if (height <= DeviceWidthObject[devc].max && height >= DeviceWidthObject[devc].min) {
                    buildDeviceDetails.deviceTypeVariant = devc;
                    break;
                }
            }
        }
        else if (width <= IdDeviceBreakpointsByWidth.tablet_max && width >= IdDeviceBreakpointsByWidth.tablet_min) {
            // Tablet (landscape)
            buildDeviceDetails.deviceType = IdDeviceType.Tablet;
            buildDeviceDetails.deviceTypeVariant = IdDeviceTypeBreakdown.Tablet;
        }
        else if (width <= IdDeviceBreakpointsByWidth.laptop_max && width >= IdDeviceBreakpointsByWidth.laptop_min) {
            // Laptop (landscape)
            buildDeviceDetails.deviceType = IdDeviceType.Laptop;
            for (var devc in DeviceWidthObject) {
                if (width <= DeviceWidthObject[devc].max && width >= DeviceWidthObject[devc].min) {
                    buildDeviceDetails.deviceTypeVariant = devc;
                    break;
                }
            }
        }
        else {
            // Larger than Laptop (landscape)
            buildDeviceDetails.deviceType = IdDeviceType.LargerThanLaptop;
            for (var devc in DeviceWidthObject) {
                if (width <= DeviceWidthObject[devc].max && width >= DeviceWidthObject[devc].min) {
                    buildDeviceDetails.deviceTypeVariant = devc;
                    break;
                }
            }
        }
    }
    else {
        // Orientation is portrait
        buildDeviceDetails.orientation = IdDeviceOrientation.Portrait;
        for (var devc in DeviceWidthObject) {
            if (width <= DeviceWidthObject[devc].max && width >= DeviceWidthObject[devc].min) {
                buildDeviceDetails.deviceTypeVariant = devc;
                break;
            }
        }
        if (width <= IdDeviceBreakpointsByWidth.laptop_max && width >= IdDeviceBreakpointsByWidth.laptop_min) {
            buildDeviceDetails.deviceType = IdDeviceType.Laptop;
        }
        if (width <= IdDeviceBreakpointsByWidth.tablet_max && width >= IdDeviceBreakpointsByWidth.tablet_min) {
            buildDeviceDetails.deviceType = IdDeviceType.Tablet;
        }
        if (width <= IdDeviceBreakpointsByWidth.mobile_max) {
            buildDeviceDetails.deviceType = IdDeviceType.Mobile;
        }
        if (width > IdDeviceBreakpointsByWidth.laptop_max) {
            buildDeviceDetails.deviceType = IdDeviceType.LargerThanLaptop;
        }
    }
    return buildDeviceDetails;
};
//# sourceMappingURL=index.js.map